Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## de.caff.gimmix
Class ReversePathIterator

    java.lang.Object
      de.caff.gimmix.ReversePathIterator

All Implemented Interfaces:
  java.awt.geom.PathIterator

    public class ReversePathIterator

extends java.lang.Object
implements java.awt.geom.PathIterator

A path iterator which iterates over a path in the reverse direction. This is missing in the java.awt.geom package, although it's quite simple to implement. After initialization the original PathIterator is not used any longer.

There are several static convenience methods to create a reverse path iterator from a shape directly:

- `ReversePathIterator.getReversePathIterator(java.awt.Shape)` for reversing the standard path iterator
- `ReversePathIterator.getReversePathIterator(java.awt.Shape, double)` for reversing a flattened path iterator
- `ReversePathIterator.getReversePathIterator(java.awt.Shape, java.awt.geom.AffineTransform)` for reversing a transformed path iterator
- `ReversePathIterator.getReversePathIterator(java.awt.Shape, java.awt.geom.AffineTransform, double)` for reversing a transformed flattened path iterator
- `ReversePathIterator.getReversePathIterator(java.awt.Shape, int)` for reversing the standard path iterator while explicitly defining a winding rule
- `ReversePathIterator.getReversePathIterator(java.awt.Shape, double, int)` for reversing a flattened path iterator while explicitly defining a winding rule
- `ReversePathIterator.getReversePathIterator(java.awt.Shape, java.awt.geom.AffineTransform, int)` for reversing a transformed path iterator while explicitly defining a winding rule
- `ReversePathIterator.getReversePathIterator(java.awt.Shape, java.awt.geom.AffineTransform, double, int)` for reversing a transformed flattened path iterator while explicitly defining a winding rule

Field Summary

Fields inherited from interface java.awt.geom.PathIterator
`SEG_CLOSE, SEG_CUBICTO, SEG_LINETO, SEG_MOVETO, SEG_QUADTO, WIND_EVEN_ODD, WIND_NON_ZERO`

Constructor Summary
`ReversePathIterator(java.awt.geom.PathIterator original)` Create an inverted path iterator from a standard one, keeping the winding rule.
`ReversePathIterator(java.awt.geom.PathIterator original, int windingRule)` Create an inverted path iterator from a standard one.

Method Summary
`int` | `currentSegment(double[] coords)` Returns the coordinates and type of the current path segment in the iteration.
`int` | `currentSegment(float[] coords)` Returns the coordinates and type of the current path segment in the iteration.
`static java.awt.geom.PathIterator` | `getReversePathIterator(java.awt.Shape shape)` Get a reverse path iterator for a shape, keeping the shape's winding rule.
`static java.awt.geom.PathIterator` | `getReversePathIterator(java.awt.Shape shape, java.awt.geom.AffineTransform at)` Get a reverse transformed path iterator for a shape, keeping the shape's winding rule.
`static java.awt.geom.PathIterator` | `getReversePathIterator(java.awt.Shape shape, java.awt.geom.AffineTransform at, double flatness)` Get a reverse transformed flattened path iterator for a shape, keeping the shape's winding rule.
`static java.awt.geom.PathIterator` | `getReversePathIterator(java.awt.Shape shape, java.awt.geom.AffineTransform at, double flatness, int windingRule)` Get a reverse transformed flattened path iterator for a shape.
`static java.awt.geom.PathIterator` | `getReversePathIterator(java.awt.Shape shape, java.awt.geom.AffineTransform at, int windingRule)` Get a reverse transformed path iterator for a shape.
`static java.awt.geom.PathIterator` | `getReversePathIterator(java.awt.Shape shape, double flatness)` Get a reverse flattened path iterator for a shape, keeping the shape's winding rule.
`static java.awt.geom.PathIterator` | `getReversePathIterator(java.awt.Shape shape, double flatness, int windingRule)` Get a reverse flattened path iterator for a shape.
`static java.awt.geom.PathIterator` | `getReversePathIterator(java.awt.Shape shape, int windingRule)` Get a reverse path iterator for a shape.
`int` | `getWindingRule()` Returns the winding rule for determining the interior of the path.
`boolean` | `isDone()` Tests if the iteration is complete.
`void` | `next()` Moves the iterator to the next segment of the path forwards along the primary direction of traversal as long as there are more points in that direction.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### ReversePathIterator

    public ReversePathIterator(java.awt.geom.PathIterator original)

  Create an inverted path iterator from a standard one, keeping the winding rule.

  Parameters:
    `original` - original iterator

### ReversePathIterator

    public ReversePathIterator(java.awt.geom.PathIterator original,
                               int windingRule)

  Create an inverted path iterator from a standard one.

  Parameters:
    `original` - original iterator
    `windingRule` - winding rule of newly created iterator

Method Detail

### getReversePathIterator

    public static java.awt.geom.PathIterator getReversePathIterator(java.awt.Shape shape)

  Get a reverse path iterator for a shape, keeping the shape's winding rule.

  Parameters:
    `shape` - shape for which a reverse path iterator is needed
  Returns:
    reverse path iterator

### getReversePathIterator

    public static java.awt.geom.PathIterator getReversePathIterator(java.awt.Shape shape,
                                                                    double flatness)

  Get a reverse flattened path iterator for a shape, keeping the shape's winding rule.

  Parameters:
    `shape` - shape for which a reverse flattened path iterator is needed
    `flatness` - flatness epsilon
  Returns:
    reverse flattened path iterator

### getReversePathIterator

    public static java.awt.geom.PathIterator getReversePathIterator(java.awt.Shape shape,
                                                                    java.awt.geom.AffineTransform at)

  Get a reverse transformed path iterator for a shape, keeping the shape's winding rule.

  Parameters:
    `shape` - shape for which a reverse transformed path iterator is needed
  Returns:
    reverse transformed path iterator

### getReversePathIterator

    public static java.awt.geom.PathIterator getReversePathIterator(java.awt.Shape shape,
                                                                    java.awt.geom.AffineTransform at,
                                                                    double flatness)

  Get a reverse transformed flattened path iterator for a shape, keeping the shape's winding rule.

  Parameters:
    `shape` - shape for which a reverse transformed flattened path iterator is needed
    `flatness` - flatness epsilon
  Returns:
    reverse transformed flattened path iterator

### getReversePathIterator

    public static java.awt.geom.PathIterator getReversePathIterator(java.awt.Shape shape,
                                                                    int windingRule)

  Get a reverse path iterator for a shape.

  Parameters:
    `shape` - shape for which a reverse path iterator is needed
    `windingRule` - winding rule of newly created iterator
  Returns:
    reverse path iterator

### getReversePathIterator

    public static java.awt.geom.PathIterator getReversePathIterator(java.awt.Shape shape,
                                                                    double flatness,
                                                                    int windingRule)

  Get a reverse flattened path iterator for a shape.

  Parameters:
    `shape` - shape for which a reverse flattened path iterator is needed
    `flatness` - flatness epsilon
    `windingRule` - winding rule of newly created iterator
  Returns:
    reverse flattened path iterator

### getReversePathIterator

    public static java.awt.geom.PathIterator getReversePathIterator(java.awt.Shape shape,
                                                                    java.awt.geom.AffineTransform at,
                                                                    int windingRule)

  Get a reverse transformed path iterator for a shape.

  Parameters:
    `shape` - shape for which a reverse transformed path iterator is needed
    `windingRule` - winding rule of newly created iterator
  Returns:
    reverse transformed path iterator

### getReversePathIterator

    public static java.awt.geom.PathIterator getReversePathIterator(java.awt.Shape shape,
                                                                    java.awt.geom.AffineTransform at,
                                                                    double flatness,
                                                                    int windingRule)

  Get a reverse transformed flattened path iterator for a shape.

  Parameters:
    `shape` - shape for which a reverse transformed flattened path iterator is needed
    `flatness` - flatness epsilon
    `windingRule` - winding rule of newly created iterator
  Returns:
    reverse transformed flattened path iterator

### getWindingRule

    public int getWindingRule()

  Returns the winding rule for determining the interior of the path. This just returns the winding rule of the original path, which may or may not be what is wanted.

  Specified by:
    `getWindingRule` in interface `java.awt.geom.PathIterator`
  Returns:
    the winding rule.
  See Also:
    `PathIterator.WIND_EVEN_ODD`, `PathIterator.WIND_NON_ZERO`

### next

    public void next()

  Moves the iterator to the next segment of the path forwards along the primary direction of traversal as long as there are more points in that direction.

  Specified by:
    `next` in interface `java.awt.geom.PathIterator`

### isDone

    public boolean isDone()

  Tests if the iteration is complete.

  Specified by:
    `isDone` in interface `java.awt.geom.PathIterator`
  Returns:
    `true` if all the segments have been read; `false` otherwise.

### currentSegment

    public int currentSegment(double[] coords)

  Returns the coordinates and type of the current path segment in the iteration. The return value is the path-segment type: SEG_MOVETO, SEG_LINETO, SEG_QUADTO, SEG_CUBICTO, or SEG_CLOSE. A double array of length 6 must be passed in and can be used to store the coordinates of the point(s). Each point is stored as a pair of double x,y coordinates. SEG_MOVETO and SEG_LINETO types returns one point, SEG_QUADTO returns two points, SEG_CUBICTO returns 3 points and SEG_CLOSE does not return any points.

  Specified by:
    `currentSegment` in interface `java.awt.geom.PathIterator`
  Parameters:
    `coords` - an array that holds the data returned from this method
  Returns:
    the path-segment type of the current path segment.
  See Also:
    `PathIterator.SEG_MOVETO`, `PathIterator.SEG_LINETO`, `PathIterator.SEG_QUADTO`, `PathIterator.SEG_CUBICTO`, `PathIterator.SEG_CLOSE`

### currentSegment

    public int currentSegment(float[] coords)

  Returns the coordinates and type of the current path segment in the iteration. The return value is the path-segment type: SEG_MOVETO, SEG_LINETO, SEG_QUADTO, SEG_CUBICTO, or SEG_CLOSE. A float array of length 6 must be passed in and can be used to store the coordinates of the point(s). Each point is stored as a pair of float x,y coordinates. SEG_MOVETO and SEG_LINETO types returns one point, SEG_QUADTO returns two points, SEG_CUBICTO returns 3 points and SEG_CLOSE does not return any points.

  Specified by:
    `currentSegment` in interface `java.awt.geom.PathIterator`
  Parameters:
    `coords` - an array that holds the data returned from this method
  Returns:
    the path-segment type of the current path segment.
  See Also:
    `PathIterator.SEG_MOVETO`, `PathIterator.SEG_LINETO`, `PathIterator.SEG_QUADTO`, `PathIterator.SEG_CUBICTO`, `PathIterator.SEG_CLOSE`

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD